"""
----------------------------------------------------------------
Programmer:	

Summary:

Date last modified: 
 02/08/2014 (mdl) -- built this template
 02/xx/2014 (xxx) -- you add comments here
----------------------------------------------------------------

--------------------------------------------------------------
INPUT: 	A poem from a local text (.txt) file. Each input
        file must follow this format: 
        ------------------------------
        | Poem Title (on line 1)
        | Author Name (one line 2)
        | <blank line>
        | Line #1 of the poem
        | Line #2 of the poem, etc.

OUTPUT: Prints messages to the console and produces new files
        that have deformed the poem in various ways.
        
        Backwards lines:
        The new filename will have "linesBackwards_" prepended to 
        the original filename. For example, an original input
        filename of "maryPoem.txt" will produce a new file called:
        "linesBackward_maryPoem.txt" (in the same directory).
           
        (you say more ...)

---------------------------------------------------------------
"""

# import these modules to help me
import re
import codecs
import string
import random

def main():
    
    poemFileName = "maryPoem.txt"
    
    print ("")  # blank line
    
    #(1) 
    print ("(1) Starting Reading Lines Backwards ...\n")
    readingLinesBackwards( poemFileName )
    
    #(2)
    print ("(2) Starting Randomize Lines Backwards ...\n")
    randomizeLines( poemFileName )
    
    #(3)
    print ("(3) Starting Reading Words Backwards ...\n")
    readingWordsBackwards( poemFileName )
    
    print ("\nDone.\n")

# end main()
#---------------------------------------------------------

#-----------------------\
# readingLinesBackwards  \
#---------------------------------------------------------
# This function accepts a filename as an argument
# of a (raw) text file that contains lines of a poem.
# The function reverses the lines of the poem and
# outputs the backward poem to a new file. The new
# filename will have "backwards_" prepended to the name.
#
# Each line# of the original poem will be printed to the 
# beginning of each line in the backwards poem, thus the 
# new file will have decreasing line numbers.
#---------------------------------------------------------
def readingLinesBackwards( poemFileName ):
    
    INPUT = open(poemFileName, 'r')
    
    newFileName = "linesBackwards_" + poemFileName
    OUTPUT = open(newFileName, 'w')

    # make an empty list to hold all the lines of a poem
    allLines = []
    
    poemTitle  = INPUT.readline().strip()
    poemAuthor = INPUT.readline().strip()
    
    # skip blank line after the author name
    INPUT.readline()
    
    # now read each line of the poem and store the lines in a list
    for nextLine in INPUT:
        nextLine = nextLine.strip()
        #print(nextLine)
        if (nextLine != ""):
            #for i in range(0,len(nextLine)):
                #print (nextLine[i], ord(nextLine[i]) ,end=",")
            #print ("")
            allLines.append(nextLine)
    
    # close the input (original) file
    INPUT.close()
    
    # now reverse the lines in the list
    allLines.reverse()
    
    # get the total number of lines in this poem
    totalLines = len(allLines)
    
    # print title and author
    OUTPUT.write("Lines Backwards\n")
    OUTPUT.write('Title:  {0}\n'.format( poemTitle ))
    OUTPUT.write('Author: {0}\n\n'.format( poemAuthor ))
    
    # i will start counting at the end
    i = totalLines
    
    for line in allLines:
        OUTPUT.write('{0}  {1}\n'.format(i,line) )
        i = i-1
    # end of for loop

    OUTPUT.close()  
    
# end readingLinesBackwards()
#---------------------------------------------------------


#----------------\
# randomizeLines  \
#---------------------------------------------------------
# You write the summary.
#---------------------------------------------------------
def randomizeLines( poemFileName ):
    
    INPUT = open(poemFileName, 'r')
    
    print ("\t You have to write the randomizeLines function \n")
    




 
    
# end randomizeLines()
#---------------------------------------------------------
    
    
#-----------------------\
# readingWordsBackwards  \
#---------------------------------------------------------
# You write the summary.
#---------------------------------------------------------
def readingWordsBackwards( poemFileName ):
    
    INPUT = open(poemFileName, 'r')
    
    print ("\t You have to write the readingWordsBackwards function \n")
    
    
    
    
    
# end readingWordsBackwards()
#--------------------------------------------------------- 


#--------------------\
# remove_punctuation  \
#---------------------------------------------------------
# This function accepts a string (e.g., line of a poem)
# and removes all occurances of the default list of 
# punctuation symbols (found in Python's string.punctuation)
#---------------------------------------------------------
def remove_punctuation( s ):
    s_without_punct = ""
    for letter in s:
        if letter not in string.punctuation:
            s_without_punct += letter
            
    return s_without_punct  
#--------------------------------------------------------- 


#-----------------------------------------------------
# Python starts here …
if __name__ == '__main__':
    main()
#-----------------------------------------------------
    